#!/usr/bin/perl -w
# Copyright (c) 2006 Universit de Lige, Nicolas Mazziotta 
# $Id: not versioned$
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Construit un arbre syntaxique constitu de pointeurs  partir
# d'un texte segment.

use strict;		

# Init

my ($name,$execpath,$suffix);

use File::Basename;

BEGIN {
  # find where the program has been installed
  my $filename = $0;
  eval {$filename = readlink $0 if -l $0};
  ($name,$execpath,$suffix) = fileparse($filename,qw/pl/);
	$execpath =~ s/\\/\//g if $^O =~ /^MSWin/;
}

use lib "$execpath/lib";
use XML::LibXML;
use Ana;
use Getopt::Std;

my %opt;
getopts('f:l:t:p:m:h', \%opt) || die ;

my $usage = <<USAGE;
$0 -l xpath [-t xpath] [-h] [-p] fichier  convertir
Options:
  -f intgre un attribut avec la forme graphique 
     des noeuds qui seront analyss. L'argument est le nom 
     de l'attribut; par exemple "forme";
  -h affiche le prsent message et sort
  -l chemin des noeuds qui feront l'objet de l'analyse, 
     sous la forme d'un xpath;
     par exemple: '/text/w'
  -m mode de cration: "work" (dfaut) ou "share"
  -p position o insrer les annotations par rapport au
     chemin indiqu par -t: "before", "after", "firstChild"
     ou "lastChild" (par dfaut)
  -t chemin o insrer les annotations converties;
     par exemple: './back/div[2]' (/ par dfaut)
USAGE

if ($opt{h} or !$opt{l}) { die $usage; }
if (!$opt{t}) { print STDERR "Aucune destination spcifie par '-t'.
Je mets l'analyse dans la racine du document.\n";
	$opt{t} = '/*';
}
if (!$opt{m}) { print STDERR "Aucun mode de cration spcifi par '-m'.
Je cre un arbre de travail.\n";
	$opt{m} = "work";
}

my ($origin_xpath, $target_xpath, $position, $mode, $formes) 
			= 
   ($opt{l}, $opt{t}, $opt{p}, $opt{m}, $opt{f});

foreach (@ARGV) {

	my $parser = XML::LibXML->new();
	my $doc = eval {$parser->parse_file($_)};
	die $@ if $@;
	
	eval {
		$doc->AnaBuild($origin_xpath, $target_xpath, $position, $mode, $formes);
		print $doc->toString(1);
	};
	die $@ if $@;

}



__END__

# vim:sw=2 ts=2 

