#!/usr/bin/perl -w
# Copyright (c) 2006 Universit de Lige, Nicolas Mazziotta 
# $Id: not versioned$
# This program is free software; you can redistribute it and/or
# modify it under the same terms as Perl itself.
#
# Effectue les conversions du format de travail au format 
# d'change et inversement

use strict;		

# Init

my ($name,$execpath,$suffix);

use File::Basename;

BEGIN {
  # find where the program has been installed
  my $filename = $0;
  eval {$filename = readlink $0 if -l $0};
  ($name,$execpath,$suffix) = fileparse($filename,qw/pl/);
	$execpath =~ s/\\/\//g if $^O =~ /^MSWin/;
}

use lib "$execpath/lib";
use XML::LibXML;
use Ana;
use Getopt::Std;

my %opt;
getopts('l:t:p:d:hf:', \%opt) || die ;

my $usage = <<USAGE;
$0 -l xpath [-t xpath] [-p position] [-d direction] [-h] [-f xpath] fichier  convertir
Options:
  -f active, cette option recherche tous les noeuds correspondant 
     et les efface AVANT la conversion (utile pour enlever les formes); 
     par exemple ".//L/attribute::forme" 
     (attention, notez la prsence du contexte au dbut du chemin)
  -d direction de conversion: "none", "work" (vers format de travail)
     ou "share" (vers format de partage). "none" ne convertit pas;
  -h affiche le prsent message et sort
  -l chemin du noeud o se trouvent les annotations du 
     document  convertir, sous la forme d'un xpath;
     par exemple: '/text/annotations[1]'
	-p position o insrer les annotations par rapport au
     chemin indiqu par -t: "before", "after", "firstChild"
		 ou "lastChild" (par dfaut)
	-t chemin o insrer les annotations converties;
     par exemple: './back/div[2]' (/ par dfaut)
USAGE

if ($opt{h} or !$opt{l}) { die $usage; }
if (!$opt{d}) {	print STDERR "Aucune direction spcifie par '-d'. 
Je vais essayer de deviner la direction avec le nom des balises.\n"; }
if (!$opt{t}) { print STDERR "Aucune destination spcifie par '-t'.
Je mets l'analyse dans la racine du document.\n";
	$opt{t} = '/*';
}

my ($origin_xpath, $target_xpath, $position, $direction, $xpath_to_delete) 
			= 
   ($opt{l}, $opt{t}, $opt{p}, $opt{d}, $opt{f});

foreach (@ARGV) {

	my $parser = XML::LibXML->new();
	my $doc = eval {$parser->parse_file($_)};
	die $@ if $@;
	
	eval {
		my $base_ana = $doc->AnaGet($origin_xpath);
		$base_ana->AnaPurge($xpath_to_delete) if $xpath_to_delete;
		my $converted_ana = $base_ana->AnaConvert($direction);
		my $new_doc = $doc->AnaAppend($converted_ana, $target_xpath, $position);
		print $new_doc->toString(1);
	};
	die $@ if $@;

}



__END__

# vim:sw=2 ts=2 

